/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  FUNS.CPP   --   test string class by finding       V1.0  *
 *                  functions using over-simplified          *
 *                  grammar:  function := identifier '('     *
 *                                                           *
 *  Language:       Borland C++                              *
 *  System:         Gateway 386/25, MS-DOS 5.0               *
 *  Application:    CSE 687                                  *
 *  Author:         Jim Fawcett, CST 2-127, (315)443-4454    *
 *                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <ctype.h>
#include "flines.hpp"

//----< BCstring prev_ident(BCstring& str) >---------------------//

BCstring prev_ident(BCstring& str) {

  BCstring whitespace = " \n\r\t\f";
  BCstring token;
  int indx = index(str);
  if (indx <= 0) return token;
  while(is_in(str[--indx],whitespace))        // back over whitespace
    if (indx == 0) return token;
  int save = index(str);
  while((isalnum(str[indx]))||(str[indx] == '_'))  // back over token
    if (indx > 0) indx--;
    else          return token;
  str[indx+1];
  token = tail(str);
  token[save-indx];
  token = head(token);
  return token;
}

/*----< void main() >----------------------------------------*/

int main(int argc, char *argv[]) {

  if (argc < 2) {
    cerr << "please invoke with input data filename\n";
    return 1;
  }
  cout << "\n" << argv[0] << " Testing " << argv[1] << "\n\n";
  fline line(argv[1]);
  while(!done(line)) {
    next(line);
    collect_comments(line);
    if (match(line.str,"(") != 0) {
      BCstring token = prev_ident(line.str);
      if (token == "if"   ) continue;
      if (token == "for"  ) continue;
      if (token == "while") continue;
      if (!isalnum(token[0])) continue;
      cout << token;
      token = collect_parens(line);
      cout << token << "\n";
    }
  }
  return 0;
}
